package commandSystem;

import Events.CallFromElevatorEvent;
import Events.CallFromFloorEvent;
import Events.ReachedFloorEvent;

public class Test {

	private static boolean running = false;
	private static BasicInstructionQueue queue;

	private static Direction currentDirection;
	private static int currentFloor;

	public static void iter() {
		int nextDestination = queue.getNextInstruction();
		
		if (!running) {
			// would be -1 if the queue doesn't have any next instruction
			if (nextDestination != -1) {
				running = true;
				currentDirection = currentFloor < nextDestination ? Direction.UP : Direction.DOWN;
			}
		} else {
			// if we just reached a new floor
			if (currentFloor == nextDestination) {
				queue.computeEvent(new ReachedFloorEvent(currentFloor, currentDirection));
				running = false;
			} else {
				currentDirection = currentFloor < nextDestination ? Direction.UP : Direction.DOWN;
				currentFloor += currentDirection == Direction.UP ? 1 : -1;
			}
		}
		System.out.println("elevator floor " + currentFloor + " direction " +
			 (currentDirection == Direction.UP? "up" : "down") + " running: " + running);
	}

	public static void main(String[] args) {
		//TODO envoyer les notifs de changements d'étages
		queue = new BasicInstructionQueue();
		iter();
		iter();
		queue.computeEvent(new CallFromFloorEvent(2, Direction.DOWN));
		iter();
		System.out.println("someone calls from floor 2 to go down");
		iter();
		queue.computeEvent(new CallFromFloorEvent(1, Direction.UP));
		System.out.println("someone calls from floor 1 to go up");
		iter();

		queue.computeEvent(new CallFromElevatorEvent(5));
		System.out.println("the guy who entered calls for floor 5");

		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();

	}
}
